
import AnimationInterfaceShell;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Canvas;
import java.awt.Dimension;

class GraphicsPane extends Canvas
	{
	//my container (some display screen manager)
	protected AnimationInterfaceShell container;

	//do i need double-buffering??
	protected Image offscreenImage;
	protected Graphics offsceenGraphics;

	///////////////////////////////////////////////////////////////////
	public GraphicsPane(AnimationInterfaceShell container)
		{
		//save my container for callbacks later
		this.container = container;
		}

	///////////////////////////////////////////////////////////////////
	public void init()
		{
		System.out.println("GraphicsPane.init()");

		try
			{
			Dimension myDimensions = this.getSize();
			offscreenImage = this.createImage(myDimensions.width, myDimensions.height);
			offsceenGraphics = offscreenImage.getGraphics();
			}
		catch (Exception ignored)
			{
			offsceenGraphics = null;
			}
		}

	///////////////////////////////////////////////////////////////////
	public void paint(Graphics graphicsContext)
		{
		System.out.println("GraphicsPane.paint()");

		if (offsceenGraphics == null)
			{
			System.out.println("no double-buffering available");

			container.offscreenPaint(graphicsContext);
			}
		else
			{
			System.out.println("using double-buffering");

			//my container gives me an image and i paint it to the screen
			container.offscreenPaint(offsceenGraphics);
			graphicsContext.drawImage(offscreenImage, 0, 0, this);
			}
		}

	///////////////////////////////////////////////////////////////////
	public void update(Graphics graphicsContext)
		{
		System.out.println("GraphicsPane.update()");

		//reduce flicker
		paint(graphicsContext);
		}
	}
