
import Rectangle;
import Moveable;
import Tuple;
import IllegalRectangleArgumentsException;

class MoveableRectangle extends Rectangle
	implements Moveable
	{

	///////////////////////////////////////////////////////////////////
	public MoveableRectangle(int xMin, int yMin, int width, int height)
		throws IllegalRectangleArgumentsException
		{
		super(xMin, yMin, width, height);
		}

	///////////////////////////////////////////////////////////////////
	public void moveX(double xDirection)
		{
		/*
		Move myself horizontally.
		*/

		xMin += (int) Math.round(xDirection);
		xMax += (int) Math.round(xDirection);
		}

	///////////////////////////////////////////////////////////////////
	public void moveY(double yDirection)
		{
		/*
		Move myself vertically.
		*/

		yMin += (int) Math.round(yDirection);
		yMax += (int) Math.round(yDirection);
		}

	///////////////////////////////////////////////////////////////////
	public void move(double xDirection, double yDirection)
		{
		/*
		Move myself in an arbitrary direction.
		*/

		moveX(xDirection); moveY(yDirection);
		}

	///////////////////////////////////////////////////////////////////
	public void move(Tuple direction)
		{
		/*
		Move myself in an arbitrary direction.
		*/

		moveX(direction.x); moveY(direction.y);
		}
	}
